#include <OneWire.h>
#include <DallasTemperature.h>
#include <LiquidCrystal.h>
#include <DFR_LCD_Keypad.h>

// this is factory config shield initialisation
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// below is for shield which has been modified (author's shield)
//LiquidCrystal lcd(8,3,4,5,6,7);

// initialise the keypad
DFR_LCD_Keypad keypad(A0, &lcd);

int last_key, key;

// Data wire is plugged into digital pin 2 on the Arduino
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);

// arrays to hold device addresses
DeviceAddress insideThermometer, outsideThermometer;


int deviceCount = 0;
float tempC;
float t;
float t1;
float t2;
float t3;
float t4;
float t1h;
float t2h;
float t3h;
float t4h;
float t1L = 200.00;
float t2L = 200.00;
float t3L = 200.00;
float t4L = 200.00;


void setup(void)
{
  lcd.begin(16, 2);
  lcd.clear();

  lcd.setCursor(0, 0);
  lcd.print("Thermometer");

  sensors.begin();  // Start up the library
  Serial.begin(9600);

  // locate devices on the bus
  Serial.print("Locating devices...");
  Serial.print("Found ");
  deviceCount = sensors.getDeviceCount();
  Serial.print(deviceCount, DEC);
  Serial.println(" devices.");
  Serial.println("");

}

void loop(void)
{
  last_key = keypad.get_last_key();
  key      = keypad.read_key();

  // only clear and update the LCD if they key state has changed
  //if (key != last_key) {
    // key has changed
    
  // Send command to all the sensors for temperature conversion
  sensors.requestTemperatures();

  // Display temperature from each sensor
  for (int i = 0;  i < deviceCount;  i++)
  {
    Serial.print("Sensor ");
    Serial.print(i + 1);
    Serial.print(" : ");
    tempC = sensors.getTempCByIndex(i);
    Serial.print(DallasTemperature::toFahrenheit(tempC));
    // Serial.print(tempC);
    // Serial.print((char)176);//shows degrees character
    // Serial.print("C  |  ");
    //Serial.print(T(i+1));
    //Serial.print((char)176);//shows degrees character
    Serial.println(" F");
  }
   
   
   //case KEY_NONE:
     // default:
  //lcd.clear();

//////////////T1
  
  lcd.setCursor(0, 0);
  lcd.print("1");
  lcd.print(" ");
  tempC = sensors.getTempCByIndex(0);
  t1 = (DallasTemperature::toFahrenheit(tempC));
  if (t1 > t1h) {
    t1h = t1;//writes high on t1 
  }
    if (t1 < t1L) {
    t1L = t1;//writes high on t1
    }
    Serial.print("T1H ");
    Serial.println(t1h );
    Serial.print("T1L ");
    Serial.println(t1L );
    lcd.print(t1);
    lcd.print((char)223);//shows degrees character

    /////////////T2
    
    lcd.print("2");
    lcd.print(" ");
    tempC = sensors.getTempCByIndex(1);
    t2 = (DallasTemperature::toFahrenheit(tempC));
  if (t2 > t2h) {
    t2h = t2;//writes high on t1 
     }
    if (t2 < t2L) {
    t2L = t2;//writes low on t1
    }
    Serial.print("T2H ");
    Serial.println(t2h );
    Serial.print("T2L ");
    Serial.println(t2L );
    lcd.print(t2);
    lcd.print((char)223);//shows degrees character

////////////////T3

    lcd.setCursor(0, 1);
    lcd.print("3 ");
    tempC = sensors.getTempCByIndex(2);
    t3 = (DallasTemperature::toFahrenheit(tempC));
    if (t3 > t3h) {
    t3h = t3;//writes high on t1 
  }
    if (t3 < t3L) {
    t3L = t3;//writes high on t1
    }
    Serial.print("T3H ");
    Serial.println(t3h );
    Serial.print("T3L ");
    Serial.println(t3L );
    lcd.print(t3);
    lcd.print((char)223);//shows degrees character

    //////////////T4
    
    lcd.print("4");
    lcd.print(" ");
    tempC = sensors.getTempCByIndex(3);
    t4 = (DallasTemperature::toFahrenheit(tempC));
    if (t4 > t4h) {
    t4h = t4;//writes high on t1 
  }
    if (t4 < t4L) {
    t4L = t4;//writes high on t1
    }
    Serial.print("T4H ");
    Serial.println(t4h );
    Serial.print("T4L ");
    Serial.println(t4L );
    lcd.print(t4);
    lcd.print((char)223);//shows degrees character

    Serial.println("");
   
switch (key) {

  
    //Display High temps
    
    case KEY_UP:
    
        lcd.setCursor(0, 0);
        lcd.print("1 ");
        lcd.print(t1h);
        lcd.print((char)223);//shows degrees character
        lcd.print("2 ");
        lcd.print(t2h);
        lcd.setCursor(0, 1);
        lcd.print("3 ");
        lcd.print(t3h);
        lcd.print((char)223);//shows degrees character
        lcd.print("4 ");
        lcd.print(t4h);
        break;

        //Display Low temps

        case KEY_DOWN:

        lcd.setCursor(0,0);
        lcd.print("1 ");
        lcd.print(t1L);
        lcd.print((char)223);//shows degrees character
        lcd.print("2 ");
        lcd.print(t2L);
        lcd.setCursor(0, 1);
        lcd.print("3 ");
        lcd.print(t3L);
        lcd.print((char)223);//shows degrees character
        lcd.print("4 ");
        lcd.print(t4L);
        break;
        }
    
  
    delay(1000);
}
